//+------------------------------------------------------------------+
//|                                  Chandes Momentum Oscillator.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers  1
#property indicator_color1   DeepSkyBlue
#property indicator_level1   50
#property indicator_level2  -50
#property indicator_levelcolor DimGray
#property indicator_width1   2

//
//
//
//
//

extern string  TimeFrame   = "Current time frame";
extern int     CMOPeriods  = 14;
extern bool    Interpolate =  true;

//
//
//
//
//

double CMOBuffer[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   SetIndexBuffer(0,CMOBuffer);
   SetIndexLabel(0,"Chande\'s Momentum Oscillator");

   //
   //
   //
   //
   //

      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame=="returnBars";     if (returnBars)     return(0);
      calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" CMO ("+CMOPeriods+")");
   return(0);
}
int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int limit,i,n,counted_bars=IndicatorCounted();

   if(counted_bars < 0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;
           if (returnBars) { CMOBuffer[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
      for(i=limit; i>=0; i--)
      {
         double sum1=0.00;
         double sum2=0.00;
         for (int k=0; k<CMOPeriods; k++)
         {
            if (Close[i+k] > Close[i+k+1]) sum1 += Close[i+k] - Close[i+k+1];
            if (Close[i+k] < Close[i+k+1]) sum2 += Close[i+k+1] - Close[i+k];
         }
         if ((sum1+sum2) != 0)
               CMOBuffer[i] = 100*(sum1-sum2)/(sum1+sum2);
         else  CMOBuffer[i] = 0.00;
      }
      return(0);
   }
         
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         CMOBuffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",CMOPeriods,0,y);

         //
         //
         //
         //
         //
         
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(k = 1; k < n; k++)
               CMOBuffer[i+k] = CMOBuffer[i] + (CMOBuffer[i+n]-CMOBuffer[i])*k/n;
   }            
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}